// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.3.0
//                        (increment this number EVERY time you make a change)
//
// 2.3.0        26 Jun 1997     Jill Baker
//      Original version
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 * This library and applications are FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the conditions within the COPYRIGHT file are adhered to.
 *
 */

package cryptix.io;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Date;
import java.util.Vector;

/**
 * @author Jill Baker
 */
public class FilterUserInterface extends UserInterface
{
    /**
	 * Display a status message
	 * @param message the message to be displayed
	 */
	public void status( String message )
    {
        if (verbose) System.err.println( message );
    }

	/**
	 * Clear any existing status message
	 */
	public void status(){}

	/**
	 * Notify the user of something
	 * @param message the message to be displayed
	 */
	public void notice( String message )
    {
        System.err.println( message );
    }

	/**
	 * Warn the user of something
	 * @param message the message to be displayed
	 */
	public void warning( String message )
    {
        System.err.println( Lang.translate( "Warning" ) + ": " + message );
    }

	/**
	 * Inform the user of an error
	 * @param message the message to be displayed
	 */
	public void error( String message )
    {
        System.err.println( Lang.translate( "Error" ) + ": " + message );
    }

	/**
	 * Prompt the user for a yes or no answer, and specify a default
	 * @param prompt the question to be displayed
	 * @returns true if yes, false if no
	 */
	public boolean promptYesNo( String prompt, boolean def )
    {
        return def;
    }

	/**
	 * Prompt the user for one of two choices
	 * @param prompt the question to be displayed
     * @param posText text for the positive button
     * @param negText text for the negative button
     * @param def default value
	 * @returns true if the positive button was pressed, false if the negative button was pressed.
	 */
	public boolean promptBoolean( String prompt, String posText, String negText, boolean def )
    {
        return def;
    }

    /**
     * Prompt the user for a String.
	 * @param prompt the question to be displayed
	 * @returns the String input.
     */
    public String promptString( String prompt )
    {
        return "";
    }

    /**
     * Prompt the user for a filename.
	 * @param prompt the question to be displayed
     * @param save true if file is to be saved, false if it is to be loaded
	 * @returns the file selected. (This is not guaranteed to exist).
     */
    public File promptFilename( String prompt, boolean save )
    {
        return new File( "" );
    }

    /**
     * Prompt the user for a selection from a list.
	 * @param prompt the question to be displayed
     * @param list Vector of Strings to be selected from
     * @param allowOthers true if user is allowed to type in entries not in the list
	 * @returns the file selected. (This is not guaranteed to exist).
     */
    public String promptFromList( String prompt, Vector list, boolean allowOthers )
    {
        return (String) list.elementAt(0);
    }

	/**
	 * Prompt the user for a passphrase.
	 * @param prompt the prompt to be displayed
     * @charset charset for character conversion
	 */
	public void getPassphrase( String prompt, String charset )
    {
    }

    /**
     * Prompt the user for some entropy
     */
    public void getEntropy( int numBytes )
    {
        addEntropy( new byte[ numBytes ] );
    }

}
