// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.3.2
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.3.2        02 Jul 1997     Jill Baker
//      Moved class from cryptix.ui to cryptix.io
//
// 2.3.1       28 May 1997      Jill Baker
//      Test stuff added. Now stores multiple Properties in a Vector.
//      Methods getTranslator(), setTranslator deleted.
//      Methods addTranslator(), removeTranslator() added.
//
// 2.3.0        28 May 1997     Jill Baker
//      Original version
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 * This library and applications are FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the conditions within the COPYRIGHT file are adhered to.
 *
 */

package cryptix.io;

import java.util.Enumeration;
import java.util.Properties;
import java.util.Vector;

/**
 * @author Jill Baker
 */
public class Lang
{
    private static Vector /*of Properties*/ translator = new Vector();
    public static boolean test = false;

    /**
     * Add a new Properties table to be used for translation.
     * Translators are used in last-in-first-out order, so any translator you add will
     * have precedence oven any translator already present.
     *
     * @param newTranslator the Properties instance containing the translation strings.
     */
    public static synchronized void addTranslator( Properties newTranslator )
    {
        translator.insertElementAt( newTranslator, 0 );
    }

    /**
     * Remove a Properties table containing translation strings.
     *
     * @param oldTranslator translation Properties to be removed.
     * @return true if the argument was a component of this vector; false otherwise.
     */
    public static synchronized boolean removeTranslator( Properties oldTranslator )
    {
        return translator.removeElement( oldTranslator );
    }
    
    /**
     * Translate text from application's language to the user's local language.<p>
     *
     * Note that although Cryptix library uses British English as its application language,
     * this is <i>not</i> a requirement for other users of this class.
     * You can use Swahili as your application language if you want.
     *
     * @param appText Text in application language
     * @return Text in local language
     */
    public static synchronized String translate( String appText )
    {
        if (test) return "{" + appText + "}";

        Enumeration e = translator.elements();
        while (e.hasMoreElements())
        {
            Properties p = (Properties) e.nextElement();
            String s = p.getProperty( appText );
            if (s != null) return s;
        }
        return appText;
    }

    /**
     * Insert a parameter (eg. a filename) into a string. This would normally be done
     * <i>after</i> language translation. This function replaces the first occurence
     * of "[]" with any text.
     *
     * @param before Text which is expected to contain at least one occurence of "[]".
     * @param sub Text for which the first occurance of "[]" in <samp>before</samp>
     *    will be substituted.
     * @return Text with substitution made.
     */
    public static String escape( String before, String sub )
    {
        int pos = before.indexOf( "[]" );
        return (pos != -1) ? before.substring( 0, pos ) + sub + before.substring( pos+2 ) : before;
    }

    /**
     * This function is provided as a convenience method. (It could easily be implemented
     * manually by calling escape( String, String ) twice).
     *
     * @param before Text which is expected to contain at least two occurences of "[]".
     * @param sub1 Text for which the first occurance of "[]" in <samp>before</samp>
     *    will be substituted.
     * @param sub1 Text for which the second occurance of "[]" in <samp>before</samp>
     *    will be substituted.
     * @return Text with substitutions made.
     */
    public static String escape( String before, String sub1, String sub2 )
    {
        return escape( escape( before, sub1 ), sub2 );
    }

}
