// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.5.1
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.5.1        15 Apr 1997     Jill Baker
//      imports changed to new namespace
//
// 2.5.0        24 Mar 1997     Original Author not stated
//      Original version
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 */

/**
 * <hr>
 * <P>
 * <bold>Copyright</bold> &#169 1995, 1996, 1997
 * <a href="http://www.systemics.com/">Systemics Ltd</a>
 * on behalf of the
 * <a href="http://www.systemics.com/docs/cryptix/">
 * Cryptix Development Team</a>.
 * All rights reserved.
 */
 
package cryptix.pgp;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import cryptix.math.BigInteger;
import cryptix.math.MPI;

import cryptix.security.rsa.PublicKey;

public final class PublicKeyCertificate extends Certificate
{
	private PublicKey publickey;

	public PublicKeyCertificate( PublicKey publickey0 )
	{
		publickey = publickey0;
	}
	
	public PublicKeyCertificate( DataInput in, int length )
	throws IOException
	{
		super( in, length );
	}

	public void 
	read( DataInput in, int length )
	throws IOException
	{
		super.read( in, length );
		if ( in.readByte() != 0x01 ) // RSA algorithm identifier.
			throw new FormatException( "Incorrect algorithm identifier." );
		BigInteger n = MPI.read( in );
		BigInteger e = MPI.read( in );
		publickey = new PublicKey( n, e );
	}

	public int
	write( DataOutput out )
	throws IOException
	{
		byte tmp[];
		int len = super.write( out ) + 1;
		out.write( 0x01 );
		out.write( tmp = MPI.save( publickey.n() ) );
		len += tmp.length;
		out.write( tmp = MPI.save( publickey.e() ) );
		len += tmp.length;
		return len;
	}

	public PublicKey publicKey() { return publickey; }

	// To be removed:
	public PublicKey publickey() { return publickey; }

	public String
	toString()
	{
		return "Public Key Certificate: " + super.toString() + "\n" + publickey.toString();
	}
}
