// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.5.2
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.5.2        13 Jun 1997     Jill Baker
//      replaced deprecated constructor String(byte[],0)
//      with non-deprecated factory method LegacyString.toString(byte[]).
//
// 2.5.1        15 Apr 1997     Jill Baker
//      imports changed to new namespace
//
// 2.5.0        24 Mar 1997     Original Author not stated
//      Original version
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 */

package cryptix.pgp;

import java.io.*;
import cryptix.mime.LegacyString;
import cryptix.security.rsa.PublicKey;

public final class SignedData
{
	public byte[] data;
	public Signature signature;

	public ByteArrayInputStream
	dataAsByteArrayInputStream()
	{
		return new ByteArrayInputStream(data);
	}

	public String
	dataAsString()
	{
		return LegacyString.toString(data);
	}

	public
	SignedData(byte[] data, Signature sig)
	{
		this.data = data;
		this.signature = sig;
	}

	public KeyID
	getKeyId()
	{
		return signature.getKeyId();
	}

	public byte[]
	keyId()
	{
		return signature.keyId();
	}

	public boolean
	verify(PublicKey key)
	{
		return signature.verify(key, data);
	}
}
