// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.3.0
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.3.0        16 May 1997     Jill Baker
//      Original Version
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 * This library and applications are FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the conditions within the COPYRIGHT file are adhered to.
 *
 */

package cryptix.pgp.engine;

import cryptix.pgp.*;
import cryptix.pgp.engine.toolkit.*;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;
import java.util.StringTokenizer;

/**
 * @author Jill Baker
 */
public final class Config
{
    private Properties properties;
    private boolean ok = false;

    public Config()
    {
        properties = new Properties();
    }

    public Config( String filename )
    {
        File f = new File( filename );
        if (f.exists())
        {
            try
            {
                properties = new Properties();
                FileInputStream fis = new FileInputStream( f );
                BufferedInputStream bis = new BufferedInputStream( fis );
                StringBuffer sb = new StringBuffer();
                for (int c=bis.read(); c!=-1; c=bis.read()) sb.append( (char)c );
                String s = sb.toString();
                StringTokenizer st = new StringTokenizer( s, "\r\n" );
                while (st.hasMoreTokens())
                {
                    String line = st.nextToken().trim();
                    int len = line.length();
                    if (len == 0) continue;
                    if (line.charAt(0) == '#') continue;
                    int eqPos = line.indexOf( '=' );
                    if (eqPos > 0)
                    {
                        String name = line.substring( 0, eqPos );
                        String value = (eqPos == len) ? "" : line.substring( eqPos+1 );

                        name = name.trim().toLowerCase();
                        value = value.trim();
                        int vlen = value.length();
                        if (vlen != 0)
                        {
                            if (value.charAt(0) == '"')
                            {
                                int ePos = value.indexOf( '"', 1 );
                                if (ePos == -1) ePos = vlen;
                                value = value.substring( 1, ePos );
                            }
                            else
                            {
                                int ePos = value.indexOf( '#' );
                                if (ePos == -1) ePos = vlen;
                                value = value.substring( 0, ePos ).trim();
                            }
                        }
                        properties.put( name, value );
                    }
                }
                ok = true;
            }
            catch (Exception e){}
        }
    }

    public boolean ok()
    {
        return ok;
    }

    public String getProperty( String name )
    {
        return getProperty( name, null );
    }

    public String getProperty( String name, String def )
    {
        String s = properties.getProperty( name );
        return (s == null) ? def : s;
    }

    public int getInteger( String name )
    {
        return getInteger( name, 0 );
    }

    public int getInteger( String name, int def )
    {
        String s = properties.getProperty( name );
        if (s == null) return def;
        try { return Integer.parseInt( s ); }
        catch (Exception e) { return def; }
    }

}
