// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.3.0
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.3.0        16 May 1997     Jill Baker
//      Original Version
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 * This library and applications are FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the conditions within the COPYRIGHT file are adhered to.
 *
 */

package cryptix.pgp.engine;

import cryptix.pgp.*;
import cryptix.pgp.engine.toolkit.*;

import cryptix.io.Lang;
import cryptix.mime.LegacyString;
import cryptix.security.rsa.SecretKey;
import cryptix.util.SensitiveByteArray;
import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.util.Date;
import java.util.Properties;

/**
 * @author Jill Baker
 */
public final class Utility
{
    public static PrintWriter debug = null;

    public static void dPrintln( String s )
    {
        if (debug != null) debug.println( "DEBUG: " + s );
    }

    public static String getKeyInfo( KeyRingEntry kre )
    {
        SecretKeyCertificate cert = (SecretKeyCertificate)kre.certificate();

        // Get its name.
        String line1 = Lang.translate( "Key for user ID" ) + ": " + kre.primaryName();

        // Get the number of bits
        int bits = kre.bitLength();

        // Get the user ID as a string;
        String uidString = cert.id().toString().substring( 14 );

        // Get the creation date
        Date date = cert.timestamp();
        DateFormat dateFormat = DateFormat.getDateInstance( DateFormat.LONG );
        String dateString = dateFormat.format( date );

        // Put all the bits together
        String line2 = bits + "-" + Lang.translate( "bit key" ) + ", " +
            Lang.translate( "key ID" ) + " " + uidString + ", " +
            Lang.translate( "created" ) + " " + dateString;

        return line1 + "\n" + line2;
    }

}
