// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.2.2
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.2.2        25 Jun 1997     Jill Baker
//      Introduced intermediate version number.
//      Added cryptix own Properties.
//
// 2.2.1        17 Apr 1997     Jill Baker
//      Moved this file here from old namespace
//
// 2.2.0        17 Apr 1997     Jill Baker
//      Increased MINOR_VERSION.
//      Corrected javadoc comment.
//      Added function getVersionString();
//
// 2.0.0        24 Mar 1997     Original Author not stated
//      No history before this date
//

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 * This library and applications are FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the conditions within the COPYRIGHT file are adhered to.
 *
 */

package cryptix.security;

import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;
import java.util.StringTokenizer;

/**
 * This class defines the version number of the Cryptix library
 * <p>Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 */
public final class Cryptix
{
	private final static int MAJOR_VERSION = 2;
    private final static int MINOR_VERSION = 2;
    private final static int INTER_VERSION = 2;

    private final static Properties props = new Properties();

    static
    {
        String classPath = System.getProperty( "java.class.path" );
        String pathSeparator = System.getProperty( "path.separator" );
        String fileSeparator = System.getProperty( "file.separator" );
        String propertiesRelPath = fileSeparator + "cryptix" + fileSeparator + 
            "security" + fileSeparator + "cryptix.properties";
        StringTokenizer st = new StringTokenizer( classPath, pathSeparator );
        while (st.hasMoreTokens())
        {
            String s = st.nextToken() + propertiesRelPath;
            File f = new File( s );
            if (f.isFile())
            {
                try
                {
                    FileInputStream in = new FileInputStream( f );
                    props.load( in );
                    in.close();
                    break;
                }
                catch (Exception e){}
            }
        }
    }

	public final static int getMajorVersion()
	{
		return MAJOR_VERSION;
	}

	public final static int getMinorVersion()
	{
		return MINOR_VERSION;
	}


    public final static int getIntermediateVersion()
    {
        return INTER_VERSION;
    }

    public final static String getVersionString()
    {
        if (INTER_VERSION == 0)
            return "Cryptix " + MAJOR_VERSION + "." + MINOR_VERSION;
        else
            return "Cryptix " + MAJOR_VERSION + "." + MINOR_VERSION + "." + INTER_VERSION;
    }

    public final static String getProperty( String name )
    {
        return props.getProperty( name );
    }
}
