// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.5.2
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.5.2        11 Jun 1997     Jill Baker
//      Changed definition of hashCode() method. It is now a checksum.
//      theSame() is now protected. toString() no longer uses deprecated method.
//      new constructor (String). Deprecated toByteArray() because it had a
//      silly name - now use getData() instead.
//
// 2.5.1        24 Mar 1997     Jill Baker
//      Changed visibility of data[] from private to protected. There is no
//      reason why subclasses should be prohibited from accessing its data.
//
// 2.5.0        24 Mar 1997     Original author not stated
//      Start of history - no details recorded before this time
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 * This library and applications are FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the conditions within the COPYRIGHT file are adhered to.
 *
 */

package cryptix.util;

import cryptix.mime.LegacyString;
import java.io.IOException;
import java.io.DataInput;
import java.io.DataOutput;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

/**
 * A class that represents a byte array
 */
public class ByteArray
{
    protected byte data[];

    public ByteArray( byte buf[], boolean copy )
	{
		if ( copy )
		{
			int len = buf.length;
			System.arraycopy( buf, 0, data = new byte[len], 0, len );
		}
		else
			data = buf;
	
	}
	
	public ByteArray( byte buf[] )
	{
		this( buf, true );
	}
	
	public ByteArray( String s )
    {
        this( LegacyString.toByteArray( s ), false );
    }

    public int length()
	{
		return data.length;
	}
	
    /*
    public int hashCode()
	{
		switch( data.length )
		{
		case 0:
			return 0;
		case 1:
			return data[0];
		case 2:
			return ( data[0] << 8 ) ^ data[1];
		case 3:
			return ( data[0] << 16 ) ^ ( data[1] << 8 ) ^ data[2];
		default:
			break;
		}
		return ( data[0] << 24 ) ^ ( data[1] << 16 ) ^ ( data[2] << 8 ) ^ data[3];
	}
    */
	
	public int hashCode()
	{
        int h = 0;
        for (int i=0; i<data.length; i++) h += data[i];
        return h;
	}
	
	public boolean equals( Object obj )
	{
		if ( obj == this ) return true;
		if ( obj instanceof ByteArray ) return theSame( this.data, ( (ByteArray)obj ).data );
		return false;
	}
	
	public String toString()
	{
		return LegacyString.toString( data );
	}
	
	public byte[] getData()
    {
		byte tmp[] = new byte[ data.length ];
		System.arraycopy( data, 0, tmp, 0, data.length );
		return tmp;
    }

    /**
     * deprecated
     */
    public byte[] toByteArray()
	{
        return getData();
	}
	
	protected static boolean theSame( byte data1[], byte data2[] )
	{
		int len1, len2;
		if ( ( len1 = data1.length ) == ( len2 = data2.length ) )
		{
			while( --len1 > 0 )
				if ( data1[len1] != data2[len1] )
					return false;
			return true;
		}
		return false;
	}
}
